<template>
  <v-dialog v-model="finalizeDialog" max-width="50%" @click:outside="close">
    <v-card class="pa-8">
      <v-card-title class="justify-center text-h5 d-flex font-weight-bold">
        {{ dialogTitle }}
      </v-card-title>
      <v-divider class="mt-2 mb-4"></v-divider>

      <v-row>
        <v-col cols="12" class="pb-0 font-weight-bold">
          <div>Nom de votre unité (pour le manifeste)</div>
        </v-col>
        <v-col cols="12" class="pt-1">
          <Field #default="{ errors, field, value }" name="Unit" rules="required" v-model="unit">
            <v-autocomplete @update:model-value="field.onChange" :model-value="value" label="Unité" density="compact"
              :error-messages="errors" :items="units" item-title="name" variant="outlined" return-object>
            </v-autocomplete>
          </Field>
        </v-col>
      </v-row>

      <v-row>
        <v-col cols="12" class="pt-0 pb-0 font-weight-bold">
          <div>Impression des documents PDF</div>
        </v-col>
        <v-col cols="12" class="pt-1">
          <v-radio-group v-model="printColor" row class="mt-0">
            <v-radio label="Couleur" data-cy="FinalizeDialogRadioColorBtn" :value="true">
            </v-radio>
            <v-radio label="Noir et blanc" data-cy="FinalizeDialogRadioBlackBtn" :value="false">
            </v-radio>
          </v-radio-group>
        </v-col>
      </v-row>

      <v-row v-if="isLmc">
        <v-col cols="12" class="pt-0 pb-0 font-weight-bold">
          <div>Last Minute Change</div>
        </v-col>
        <v-col cols="12" class="pt-1">
          <v-radio-group v-model="onlyLmc" row class="mt-0">
            <v-radio label="Générer uniquement les LMC" data-cy="FinalizeDialogRadioOnlyLMCBtn" :value="true">
            </v-radio>
            <v-radio label="Re-générer le dossier complet" data-cy="FinalizeDialogRadioFullBtn" :value="false">
            </v-radio>
          </v-radio-group>
        </v-col>
      </v-row>

      <v-card-actions class="justify-center d-flex">
        <v-btn variant="outlined" rounded size="large" class="text-uppercase" :disabled="loading" @click="close()">
          Annuler
        </v-btn>
        <v-btn color="primary" variant="outlined" rounded size="large" data-cy="FinalizeDialogConfirmBtn" class="text-uppercase inverted"
          :disabled="!meta.valid" :loading="loading" @click="confirm()">
          Valider
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { Unit } from "~/dto/unit.dto";

const finalizeDialog = defineModel<boolean>();

const props = defineProps<{
  legStatus?: string
}>();

const { units, loggedInUser } = storeToRefs(useStore());

const emit = defineEmits(['close', 'confirm'])

const unit: Ref<Unit | null | undefined> = ref(null);

unit.value = units.value.find(u => u.id === loggedInUser.value!.unit?.id);

const { validate, meta } = useForm({
  initialValues: unit.value
})

const loading = ref(false);
const printColor = ref(true);
const onlyLmc = ref(true);

const isLmc = computed(() => {
  return props.legStatus === 'lmc';
});
const close = () => {
  emit('close')
}
const confirm = async () => {
  const { valid } = await validate();
  if (!valid) {
    return;
  }
  emit('confirm', {
    'printColor': printColor.value,
    'unit': unit.value,
    'onlyLmc': onlyLmc.value
  });
  loading.value = true;
}

const dialogTitle = `Finalisation d'un leg`

</script>
